library chip;

uses
  Windows, INIFiles, SysUtils, Classes;

{$I '..\types.inc'}
{$I '..\functions.inc'}
{$R CHIP+.RES}
{$R *.RES}

var
  CDDrive:Char;

//////////////Procedury dodatkowe////////////////////
function GetItem(S:string; Num:Byte):string;
var
  A:Byte;
  B:Word;
  P1,P2:Word;
begin
  A:=0;
  P1:=0;
  P2:=0;
  try
    for B:=1 to Length(S) do
    begin
      if S[B]=#9 then
      begin
        Inc(A);
        if A=Num then P1:=B+1;
        if A=Num+1 then
        begin
          P2:=B-1;
          Break;
        end;
      end;
    end;
    Result:=Copy(S,P1,P2-P1+1);
    while Result[Length(Result)]=#9 do Result:=Copy(Result, 1, Length(Result)-1);
  except
    MessageBox(0, 'Wystpi bd. Prosz skontaktowa si z autorem.',nil,MB_OK+MB_ICONWARNING);
  end;
end;

////////////Procedury eksportowane//////////////////////////////////

procedure Info; stdcall;
begin
  MessageBox(0,'Wtyczka do programu Wyszukiwarka'#13+'Obsuguje pyty magazynu CHIP',
                         'Informacje o wtyczce',MB_OK);
end;

function PluginName:PChar; stdcall;
begin
  Result:='CHIP CD';
end;

function CDName:PChar; stdcall;
begin
  Result:='CHIP';
end;

function CanYouRegister:TCanYouRegisterResult; stdcall;
begin
  Result:=No;
  try
    if (FileExists(CDDrive+':\startuj.exe')  //nowy
       and FileExists(CDDrive+':\start.exe')
       and FileExists(CDDrive+':\index.htm')
       and FileExists(CDDrive+':\chip-cd.ico')
       and FileExists(CDDrive+':\autorun.inf')
       and FileExists(CDDrive+':\Browser\chip.skn')
       and FileExists(CDDrive+':\Browser\About.gfx')
       and FileExists(CDDrive+':\Browser\chip.avi')
       and FileExists(CDDrive+':\Browser\chip-cds.exe')
       and FileExists(CDDrive+':\Browser\Chip-cd.exe')
       and FileExists(CDDrive+':\Browser\setup.exe')
       and FileExists(CDDrive+':\Browser\Chip.cnt')
       and FileExists(CDDrive+':\Browser\chip.dat')
       and FileExists(CDDrive+':\Browser\Chip.hlp')
       and FileExists(CDDrive+':\Browser\ChipS.hlp')
       and FileExists(CDDrive+':\Browser\snd.dll'))
    or
          (FileExists(CDDrive+':\autorun.exe')    //stara
       and FileExists(CDDrive+':\Autorun.inf')
       and FileExists(CDDrive+':\Chip16.exe')
       and FileExists(CDDrive+':\Chip16.hlp')
       and FileExists(CDDrive+':\chip32.exe')
       and FileExists(CDDrive+':\Chip32.hlp')
       and FileExists(CDDrive+':\chip-cd.ico')
       and FileExists(CDDrive+':\Czytajto.wri')
       and FileExists(CDDrive+':\Hierarch.dbt')
       and FileExists(CDDrive+':\Kopiuj.hlp')
       and FileExists(CDDrive+':\kopiuj16.exe')
       and FileExists(CDDrive+':\kopiuj32.exe')
       and FileExists(CDDrive+':\Nviewl16.dll')
       and FileExists(CDDrive+':\NViewLib.dll')
       and FileExists(CDDrive+':\Obiekty.dbt')
       and FileExists(CDDrive+':\Tabela.dbt')
       and FileExists(CDDrive+':\Xcdunz32.dll')
       and FileExists(CDDrive+':\Xcdunzip.dll'))
    then Result:=Yes;
  except
    MessageBox(0, 'Wystpi bd. Prosz skontaktowa si z autorem.',nil,MB_OK+MB_ICONWARNING);
  end;
end;

function RegisterCD(var CDStream, ItemStream:TMemoryStream;
  CDHeader:TCDHeader; ShowProgress:TShowProgress):TRegisterCDResult; stdcall;
//gwna procedura rejestrujca pyt
var
  Row:string;
  IH:TItemHeader;
  CDTitle, Name, Description, Version, Cat, License:string;
  Bufor:array[0..Max_Path] of Char;
  MaxCompLength,FileSystemFlags:Cardinal;
  Serial:DWORD;
  TempMonth,TempYear:string;
  DataFile:TextFile;
  DataStream:TMemoryStream;
  Ch:Char;
  A, Lines:Word;
  Reg:array[0..999] of Boolean;
begin
  Result:=Error;
  try
    CDStream.Position:=CDStream.Size; //ustawienie strumieni na koniec
    ItemStream.Position:=ItemStream.Size;
    ItemStream.Position:=ItemStream.Size;
    ItemStream.Position:=ItemStream.Size;
    ShowProgress(0);

    if FileExists(CDDrive+':\startuj.exe') then //reg nowa
    begin
      for A:=0 to 999 do Reg[A]:=False;
      DataStream:=TMemoryStream.Create;
      DataStream.LoadFromFile(CDDrive+':\Browser\Chip.dat');
      try
        DataStream.Position:=DataStream.Size-25;
        SetLength(Row,25);
        DataStream.Read(Row[1], 25);
        while not(Row[1] in ['0'..'9']) do Delete(Row,1,1);
        while Pos(#9,Row)<>0 do Delete(Row, Length(Row), 1);
        CDHeader.Month:=StrToInt(Copy(Row,1,Pos('/',Row)-1));
        CDHeader.Year:=StrToInt(Copy(Row,Pos('/',Row)+1,Length(Row)-Pos('/',Row)));
        CDTitle:='CHIP CD';
        CDHeader.TitleLength:=Length(CDTitle);
        CDStream.Position:=CDStream.Size;
        CDStream.Write(CDHeader, SizeOf(CDHeader));
        CDStream.Write(CDTitle[1], CDHeader.TitleLength);

        DataStream.Position:=44;
        DataStream.Read(Ch,1);
        while DataStream.Size<>DataStream.Position do
        begin
          Row:='';
          while Ch<>#13 do
          begin
            Row:=Row+Ch;
            DataStream.Read(Ch,1);
          end;
          while ((Ch=#13) or (Ch=#10)) and (DataStream.Size<>DataStream.Position) do DataStream.Read(Ch,1);
          ShowProgress(100*DataStream.Position div DataStream.Size);
          if (GetItem(Row, 1)='root') or
             (GetItem(Row, 1)='hardware') or
             (GetItem(Row, 1)='chip') or
             (GetItem(Row, 1)='chip internet') or
             (GetItem(Row, 1)='software') or
             (GetItem(Row, 1)='internet') or
             (GetItem(Row, 1)='porady') or
             (StrToIntDef(GetItem(Row,0),1000)=1000) or //jeli nie liczba
             Reg[StrToInt(GetItem(Row,0))] //jeli ju zarejestrowany
             then Continue;

          Reg[StrToInt(GetItem(Row, 0))]:=True;
          ExtractNameVer(GetItem(Row, 1), Name, Version);
          Description:=GetItem(Row, 2);

          IH.CDNumber:=CDHeader.CDNumber;
          IH.NameLength:=Length(Name);
          IH.DescriptionLength:=Length(Description);
          IH.License:=None;
          IH.CompanyLength:=0;
          IH.VersionLength:=Length(Version);

          ItemStream.Position:=ItemStream.Size;
          ItemStream.Write(IH, SizeOf(IH));
          if IH.NameLength>0 then ItemStream.Write(Name[1], IH.NameLength);
          if IH.VersionLength>0 then ItemStream.Write(Version[1], IH.VersionLength);
          if IH.DescriptionLength>0 then ItemStream.Write(Description[1], IH.DescriptionLength);
        end;
      finally
        DataStream.Free;
      end;
    end
    else
    if FileExists(CDDrive+':\Chip16.exe') then //stara
    begin
      GetVolumeInformation(PChar(CDDrive+':\'), Bufor, SizeOf(Bufor), @Serial, MaxCompLength, FileSystemFlags, nil, 0);
      CDTitle:='CHIP';
      TempYear:=StrPas(Bufor);
      TempYear:=Copy(TempYear,Pos('_',TempYear)+1, Length(TempYear)-Pos('_', TempYear));
      TempMonth:=Copy(TempYear,1,Pos('_', TempYear)-1);
      TempYear:=Copy(TempYear,Pos('_', TempYear)+1, Length(TempYear)-Pos('_', TempYear)+1);
      CDHeader.Year:=StrToInt(TempYear);
      if CDHeader.Year<100 then CDHeader.Year:=CDHeader.Year+1900;
      CDHeader.Month:=StrToInt(TempMonth);
      CDHeader.TitleLength:=Length(CDTitle);
      CDStream.Write(CDHeader,SizeOf(CDHeader));
      CDStream.Write(CDTitle[1],CDHeader.TitleLength);

      AssignFile(DataFile, CDDrive+':\Tabela.dbt');
      Reset(DataFile);

      Lines:=0;//liczenie wierszy
      while not Eof(DataFile) do
      begin
        Read(DataFile,Ch);
        if Eoln(DataFile) then Inc(Lines);
      end;
      CloseFile(DataFile);

      Reset(DataFile);

      while not Eoln(DataFile) do//pominicie pierwszej linii
      begin
        Read(DataFile,Ch);
      end;
      Read(DataFile,Ch); //#10

      for A:=2 to Lines-1 do
      begin
        ShowProgress(100*a div Lines);

        Row:='';
        while not Eoln(DataFile) do//odczytanie linii
        begin
          Read(DataFile,Ch);
          Row:=Row+Ch;
        end;
        Read(DataFile,Ch); //#10

        //bez tego zostaoby zarejestrowane kilka kopii tego samego programu...
        if StrtoInt(GetItem(Row, 4))>1000 then Continue;

        Name:=GetItem(Row, 5);
        Description:=GetItem(Row, 6);
        Cat:=GetItem(Row, 7);
        License:=GetItem(Row,9);

        if (License<>'') or (Cat='testsoft') or (Cat='top_ten')  then
        begin
          if License='Demonstracyjna' then IH.License:=Demo
          else
          if License='Freeware' then IH.License:=Freeware
          else
          if License='Shareware' then IH.License:=Shareware
          else
          if (License='30-dniowa')
          or (License='45-dniowa') then IH.License:=Evaluation
          else
          if License='Pena' then IH.License:=Full
          else IH.License:=None;

          ExtractNameVer(Name, Name, Version);
          IH.CDNumber:=CDHeader.CDNumber;
          IH.NameLength:=Length(Name);
          IH.VersionLength:=Length(Version);
          IH.DescriptionLength:=Length(Description);
          ItemStream.Write(IH,SizeOf(IH));
          ItemStream.Write(Name[1], IH.NameLength);
          ItemStream.Write(Version[1], IH.VersionLength);
          ItemStream.Write(Description[1], IH.DescriptionLength);
        end
        else //License=''
        begin
          IH.CDNumber:=CDHeader.CDNumber;
          IH.NameLength:=Length(Name);
          IH.DescriptionLength:=Length(Description);
          ItemStream.Write(IH, SizeOf(IH));
          ItemStream.Write(Name[1], IH.NameLength);
          ItemStream.Write(Description[1], IH.DescriptionLength);
        end;
      end;
      CloseFile(DataFile);
    end;

    Result:=Registered;
  except
    MessageBox(0, 'Wystpi bd. Prosz skontaktowa si z autorem.',nil,MB_OK);
  end;
end;

function InitializePlugin(const CDLetter:Char):Boolean;
begin
  CDDrive:=CDLetter;
  Result:=True;
end;

exports
  RegisterCD,
  CanYouRegister,
  PluginName,
  CDName,
  Info,
  InitializePlugin;
end.
