library chipsp;

uses
  SysUtils, INIFiles, Windows, Classes;

{$I '..\types.inc'}
{$I '..\functions.inc'}
{$R chipsp+.res}
{$R *.RES}

var
  CDDrive:Char;

procedure Info;
begin
  MessageBox(0, 'Wtyczka Chip Special','Informacje o...',MB_OK);
end;

function PluginName:PChar;
begin
  Result:='CHIP SPECIAL';
end;

function CDName:PChar;
begin
  Result:='CHIP SPECIAL';
end;

function CanYouRegister:TCanYouRegisterResult;
var
  CDTitle:string;
  Bufor:array[0..Max_Path] of Char;
  MaxCompLength,FileSystemFlags:Cardinal;
  Serial:DWORD;
begin
  Result:=No;
  GetVolumeInformation(PChar(CDDrive+':\'),Bufor,SizeOf(Bufor),@Serial,MaxCompLength,FileSystemFlags,nil,0);
  CDTitle:=AnsiLowerCase(StrPas(Bufor));
  if Copy(CDTitle,1,7)='katalog' then
    Result:=Yes;
end;

function RegisterCD(var CDStream, ItemStream:TMemoryStream;
  CDHeader:TCDHeader; ShowProgress:TShowProgress):TRegisterCDResult; stdcall;
var
  IH:TItemHeader;
  CDTitle:string;
  Bufor:array[0..Max_Path] of Char;
  MaxCompLength,FileSystemFlags:Cardinal;
  Serial:DWORD;
begin
  Result:=Error;
  try
    CDStream.Position:=CDStream.Size; //ustawienie strumieni na koniec
    ItemStream.Position:=ItemStream.Size;

    GetVolumeInformation(PChar(CDDrive+':\'),Bufor,SizeOf(Bufor),@Serial,MaxCompLength,FileSystemFlags,nil,0);

    ShowProgress(0);

    CDTitle:=StrPas(Bufor);
    CDTitle:=Copy(CDTitle, Pos('_',CDTitle)+1,Length(CDTitle)-Pos('_',CDTitle));
    CDHeader.Month:=13;
    CDHeader.Year:=StrToInt(CDTitle);
    if CDHeader.Year<100 then CDHeader.Year:=CDHeader.Year+1900;
    CDTitle:='Katalog oprogramowania';
    CDHeader.TitleLength:=Length(CDTitle);
    CDHeader.CDNumber:=CDHeader.CDNumber;
    CDStream.Write(CDHeader, SizeOf(CDHeader));
    CDStream.Write(CDTitle[1], CDHeader.TitleLength);

    IH.CDNumber:=CDHeader.CDNumber;
    IH.CompanyLength:=0;
    IH.DescriptionLength:=0;
    IH.NameLength:=CDHeader.TitleLength;
    IH.License:=None;
    IH.VersionLength:=0;

    ItemStream.Write(IH, SizeOf(IH));
    ItemStream.Write(CDTitle[1], IH.NameLength);

    ShowProgress(100);

    Result:=Registered;
  except
  end;
end;

function InitializePlugin(const CDLetter:Char):Boolean;
begin
  CDDrive:=CDLetter;
  Result:=True;
end;

exports
  RegisterCD,
  CanYouRegister,
  PluginName,
  CDName,
  Info,
  InitializePlugin;
end.
