library enterex;

uses
  SysUtils, INIFiles, Windows, Classes, ShellAPI;

{$I '..\types.inc'}
{$I '..\functions.inc'}
{$R enterex+.RES}
{$R *.RES}

var
  CDDrive:Char;

procedure Info; stdcall;
begin
  MessageBox(0, 'Wtyczka obsugujca pyty magazynu Enter','Informacje o wtyczce',MB_OK);
end;

function PluginName:PChar; stdcall;
begin
  //zwraca tekst ktry bdzie umieszczony w menu Plugins
  Result:='Enter Extra';
end;

function CDName:PChar; stdcall;
begin
  Result:='Enter Extra';
end;

function CanYouRegister:TCanYouRegisterResult; stdcall;
var
  Bufor:array[0..Max_Path] of Char;
  MaxCompLength,FileSystemFlags:Cardinal;
  Serial:DWORD;
begin
  Result:=No;
  try
    GetVolumeInformation(PChar(CDDrive+':\'),Bufor,SizeOf(Bufor),@Serial,MaxCompLength,FileSystemFlags,nil,0);
    if Copy(StrPas(Bufor),1,8)='enter' then Result:=OnlyManual;
  except
    MessageBox(0, 'Bd podczas sprawdzania moliwosci rejestracji. Przeka pyt autorowi programu z celu aktualizacji',nil, MB_OK);
  end;
end;

function RegisterCD(var CDStream, ItemStream:TMemoryStream;
  CDHeader:TCDHeader; ShowProgress:TShowProgress):TRegisterCDResult; stdcall;
var
  Bufor:array[0..Max_Path] of Char;
  MaxCompLength,FileSystemFlags:Cardinal;
  Serial:DWORD;
  CDTitle:string;
begin
  Result:=Error;
  try
    CDStream.Position:=CDStream.Size; //ustawienie strumieni na koniec
    ItemStream.Position:=ItemStream.Size;
    ItemStream.Position:=ItemStream.Size;
    ItemStream.Position:=ItemStream.Size;

    ShowProgress(0);

    GetVolumeInformation(PChar(CDDrive+':\'),Bufor,SizeOf(Bufor),@Serial,MaxCompLength,FileSystemFlags,nil,0);
    CDTitle:='Enter';
    CDHeader.TitleLength:=Length(CDTitle);
    GetLastCdFile(CDDrive, CDHeader);
    CDStream.Write(CDHeader, SizeOf(CDHeader));
    CDStream.Write(CDTitle[1],CDHeader.TitleLength);
    if FileExists(CDDrive+':\index.htm') then
      if MessageBox(0, 'Pyta zawiera informacje o zawartoci, '+
                       'ale nie mog by one wykorzystane do automatycznej '+
                       'rejestracji.'+#13#13+'Czy otworzy plik zawierajcy te informacje ?',
                       'Uwaga',MB_YESNO) = IDYES then
        ShellExecute(GetDesktopWindow,'open',PChar(CDDrive+':\index.htm'),nil,nil,SW_Show);
    Result:=Manual;
  except
    MessageBox(0, 'Bd podczas prby rejestracji. Przeka pyt autorowi programu z celu aktualizacji',nil, MB_OK);
  end;
end;

function InitializePlugin(const CDLetter:Char):Boolean;
begin
  CDDrive:=CDLetter;
  Result:=True;
end;

exports
  RegisterCD,
  CanYouRegister,
  PluginName,
  CDName,
  Info,
  InitializePlugin;
end.
