library ep;

uses
  INIFiles, Windows, SysUtils, Classes, ShellAPI;

{$I '..\types.inc'}
{$I '..\functions.inc'}
{$R EP+.RES}
{$R *.RES}

var
  CDDrive:Char;

procedure Info; stdcall;
begin
  MessageBox(0, 'Elektronika Praktyczna','Informacje o...',MB_OK);
end;

function PluginName:PChar; stdcall;
begin
  Result:='EP';
end;

function KillApp:Boolean; stdcall;
begin
  Result:=False;
end;

function CDName:PChar; stdcall;
begin
  Result:='Elektronika Praktyczna';
end;

function CanYouRegister:TCanYouRegisterResult; stdcall;
var
  Bufor:array[0..Max_Path] of Char;
  MaxCompLength,FileSystemFlags:Cardinal;
  Serial:DWORD;
begin
  Result:=No;
  try
    GetVolumeInformation(PChar(CDDrive+':\'),Bufor,SizeOf(Bufor),@Serial,MaxCompLength,FileSystemFlags,nil,0);
    if LowerCase(Copy(StrPas(Bufor),1,4))='cdep' then Result:=OnlyManual;
    if LowerCase(Copy(StrPas(Bufor),1,5))='cd_ep' then Result:=OnlyManual;
  except
    MessageBox(0, 'Wystpi bd. Prosz skontaktowa si z autorem.',nil,MB_OK);
  end;
end;

function RegisterCD(var CDStream, ItemStream:TMemoryStream;
  CDHeader:TCDHeader; ShowProgress:TShowProgress):TRegisterCDResult; stdcall;
var
  Bufor:array[0..Max_Path] of Char;
  MaxCompLength,FileSystemFlags:Cardinal;
  Serial:DWORD;
  CDTitle:string;
  SR:TSearchRec;
begin
  Result:=Error;
  try
    CDStream.Position:=CDStream.Size; //ustawienie strumieni na koniec
    ItemStream.Position:=ItemStream.Size;
    ItemStream.Position:=ItemStream.Size;
    ItemStream.Position:=ItemStream.Size;

    ShowProgress(0);

    GetVolumeInformation(PChar(CDDrive+':\'),Bufor,SizeOf(Bufor),@Serial,MaxCompLength,FileSystemFlags,nil,0);
    CDTitle:=Copy(StrPas(Bufor),5,Length(StrPas(Bufor))-4);

    if LowerCase(Copy(StrPas(Bufor),1,4))='cdep' then CDHeader.Month:=StrToInt(Copy(CDTitle,1,Pos('_',CDTitle)-1))
    else CDHeader.Month:=StrToInt(Copy(CDTitle,2,Pos('_',CDTitle)-2));
    CDHeader.Year:=StrToInt(Copy(CDTitle,Pos('_',CDTitle)+1,Length(CDTitle)-Pos('_',CDTitle)-1));
    CDTitle:='Elektronika Praktyczna';
    CDHeader.TitleLength:=Length(CDTitle);

    CDStream.Write(CDHeader, SizeOf(CDHeader));
    CDStream.Write(CDTitle[1],CDHeader.TitleLength);
    Result:=Manual;
    if FindFirst(CDDrive+':\cdep*.exe', faAnyFile, SR)=0 then
    begin
      if MessageBox(0, 'Pyta zawiera informacje o zawartoci, '+
                        'ale nie mog by one wykorzystane do automatycznej '+
                        'rejestracji.'+#13#13+'Czy otworzy plik zawierajcy te informacje ?',
                        'Uwaga',MB_YESNO) = IDYES then
        ShellExecute(GetDesktopWindow,'open',PChar(CDDrive+':\'+SR.Name),nil,nil,SW_Show);
      end;
    FindClose(SR);
  except
    MessageBox(0, 'Wystpi bd. Prosz skontaktowa si z autorem.',nil,MB_OK);
  end;
end;

function InitializePlugin(const CDLetter:Char):Boolean;
begin
  CDDrive:=CDLetter;
  Result:=True;
end;

exports
  RegisterCD,
  CanYouRegister,
  PluginName,
  CDName,
  Info,
  KillApp,
  InitializePlugin;
end.
