//funkcje dodatkowe

function IsDigit(C:Char):Boolean;
//sprawdza czy podany znak jest liczb
begin
  if (C>#47) and (C<#58) then Result:=True
  else Result:=False;
end;

procedure ExtractNameVer(Source:string; var Name, Ver:string);
//oddziela nazw programu od jego wersji
var
  A:Byte;
begin
  if Length(Source)=0 then
    raise Exception.Create('Bd przy rozdzielaniu nazwy');
  Name:=Source;
  Ver:='';
  try
    //przygotowanie: usunicie liter v w nazwach typu: Program v0.00, Program v.0.00, Program V0.00,Program V.0.00,
    for A:=1 to Length(Source)-1 do
    begin
      if (LowerCase(Source[A])='v') and IsDigit(Source[A+1]) then
        Source[A]:=' ';
      if (LowerCase(Source[A-1])='v') and (Source[A]='.') and IsDigit(Source[A+1]) then
      begin
        Source[A]:=' ';
        Source[A-1]:=' ';
      end;
    end;
    //przeszukanie od pocztku nazwy - jeli zacznie si liczba to prawdopodobnie to jest wersja
    for A:=2 to Length(Source)-1 do//od 2 (na pocztku nigdy nie bdzie spacji) do Length-1 (bo sprawdzany te jest znak[A+1]
    begin
      if (Source[A]=' ') and IsDigit(Source[A+1]) then //znaleziono wersj
      begin
        //rozpoczynamy analiz
        Name:=Trim(Copy(Source, 1, A));
        Ver:=Trim(Copy(Source, A+1, Length(Source)-A));


        //stae cigi w nazwach, ktre nie mog by w wersji
        //12-literowe
        if (Copy(Ver, 1, 12)='2000/2003/XP') or (Copy(Ver, 1, 12)='2000/XP/2003') then
        begin
          Name:=Name+' '+Copy(Ver,1,12);
          Delete(Ver,1,12);
        end;
        //10-literowe
        if (Copy(Ver, 1, 10)='NT/2000/XP') then
        begin
          Name:=Name+' '+Copy(Ver,1,10);
          Delete(Ver,1,10);
        end;
        //7-literowe
        if (Copy(Ver, 1, 7)='2000/XP') then
        begin
          Name:=Name+' '+Copy(Ver,1,7);
          Delete(Ver,1,7);
        end;
        //5-literowe
        if (Copy(Ver, 1, 5)='95/98') then
        begin
          Name:=Name+' '+Copy(Ver,1,5);
          Delete(Ver,1,5);
        end;
        //4-literowe
        if (Copy(Ver, 1, 4)='4in1'){sterowniki VIA 4in1} then
        begin
          Name:=Name+' '+Copy(Ver,1,4);
          Delete(Ver,1,4);
        end;

        if (Copy(Ver, 1, 2)='20') and IsDigit(Ver[3]) and IsDigit(Ver[4]) then
        //w wersji jest rok 20xx wic lepiej go przenie do nazwy
        begin
          if Length(Ver)=4 {sam rok} then
          begin
            Name:=Name+' '+Ver;
            Ver:='';
          end
          else if Length(Ver)>5 then
            if Ver[5]=' ' then
            begin
              Name:=Name+' '+Copy(Ver,1,4);
              Delete(Ver,1,4);
            end;
        end;

        //2-literowe
        if (Copy(Ver, 1, 2)='2k') or (Copy(Ver, 1, 2)='NT') or (Copy(Ver, 1, 2)='XP') or (Copy(Ver, 1, 2)='16') or
           (Copy(Ver, 1, 2)='9x') or (Copy(Ver, 1, 2)='95') or (Copy(Ver, 1, 2)='98') or (Copy(Ver, 1, 2)='32')  then
        begin
          if (Length(Ver)>2) then
          begin
            if Ver[3]=' ' then
            begin
              Name:=Name+' '+Copy(Ver,1,2);
              Delete(Ver,1,2);
            end;
          end
          else
          if Length(Ver)=2 then
          begin
            Name:=Name+' '+Ver;
            Ver:='';
          end;
        end;

        if Pos('%', Ver)<>0 then
        //w wersji jest znak %, ktry nie wystpuje w nazwie wersji - poprawka dla programu Alcohol 120%
        begin
          Name:=Name+' '+Copy(Ver,1,Pos('%',Ver));
          Delete(Ver,1,Pos('%',Ver));
        end;

        if (Pos('str', Name)<>0) or
           (Pos('strona', Name)<>0) or
           (Pos('str', Ver)<>0) or
           (Pos('strona', Ver)<>0) then
          //w nazwie lub wersji jest 'str', ktry pewnie oznacza stron w czasopismie wic nie ma wersji
        begin
          Name:=Name+' '+Ver;
          Ver:=''
        end;

        Name:=Trim(Name);
        Ver:=Trim(Ver);
        Break;
      end;
    end;
  except
    MessageBox(0, 'Wystpi bd przy rozdzielanie nazwy i wersji programu. Prosz skontaktowa si z autorem.',nil,MB_OK+MB_ICONWARNING);
  end;
end;

function GetVersion(FilePath:string):string;
//pobiera wersj pliku o podanej ciece
var
  VersionSize: Integer;
  VersionHandle: DWORD;
  VersionBuf: PChar;
  VerInfo: PVSFixedFileInfo;
  VerInfoSize: UINT;
begin
  VersionSize := GetFileVersionInfoSize(PChar(FilePath), VersionHandle);
  if VersionSize <> 0 then
  begin
    GetMem(VersionBuf, VersionSize);
    try
      if GetFileVersionInfo(PChar(FilePath), VersionHandle, VersionSize, VersionBuf) then
      begin
        if VerQueryValue(VersionBuf, '\', Pointer(VerInfo), VerInfoSize) then
        begin
          Result:=
               IntToStr(VerInfo^.dwFileVersionMS div 65536)+'.'+
               IntToStr(VerInfo^.dwFileVersionMS mod 65536)+'.'+
               IntToStr(VerInfo^.dwFileVersionLS div 65536)+'.'+
               IntToStr(VerInfo^.dwFileVersionLS mod 65536);
        end;
      end;
    finally
      FreeMem (VersionBuf, VersionSize);
    end;
  end else Result:='wersja nieznana';
end;

function AddSlash(Path:string):string;
//Uzupenia podan ciek o znak '\' (jeli brak)
begin
  if Path[Length(Path)]<>'\' then
    Result:=Path+'\'
  else
    Result:=Path;
end;

function GenerateUniqueName (Path:String; const Extension:String):String;
//generuje unikaln nazw pliku dla danego folderu

  function IntToBase32 (Number: Longint): String;
  const
    Table: array[0..31] of Char = '0123456789ABCDEFGHIJKLMNOPQRSTUV';
  var
    I: Integer;
  begin
    Result := '';
    for I := 0 to 4 do begin
      Insert (Table[Number and 31], Result, 1);
      Number := Number shr 5;
    end;
  end;

var
  Rand, RandOrig: Longint;
begin
  Path := AddSlash(Path);
  RandOrig := Random($2000000);
  Rand := RandOrig;
  repeat
    Inc (Rand);
    if Rand > $1FFFFFF then Rand := 0;
    if Rand = RandOrig then
      { practically impossible to go through 33 million possibilities,
        but check "just in case"... }
      raise Exception.Create('Za duo plikw w folderze '+Path);
    { Generate a random name }
    Result := Path + IntToBase32(Rand) + '.'+Extension;
  until not FileExists(Result);
end;

function TextToLicense(License:string):TLicense;
//zamiana nazwy licencji na jej numer
begin
  Result:=None;
  License:=LowerCase(License);
  if License='shareware' then Result:=Shareware else
  if License='freeware' then Result:=Freeware else
  if License='adware' then Result:=Adware else
  if License='demonstracyjna' then Result:=Demo else
  if License='demo' then Result:=Demo else
  if License='pena' then Result:=Full else
  if License='ewaluacyjna' then Result:=Evaluation  else
  if License='trial' then Result:=Evaluation  else
  if License='pena wersja' then Result:=Full else
  if License='gpl' then Result:=GPL else
//  Application.MessageBox(PChar('nowa licencja:'+License),'qqq',MB_OK);
end;

function LicenseToText(License:TLicense):String;
//zamiana numeru licencji na jej nazw
begin
  case License of
    None:Result:='';
    Shareware:Result:='Shareware';
    Freeware:Result:='Freeware';
    Demo:Result:='Demonstracyjna';
    Full:Result:='Pena';
    Evaluation:Result:='Ewaluacyjna';
    Adware:Result:='Adware';
    GPL:Result:='GNU Public License';
  end;
end;

procedure IsoToCp(var Text:string);
//konwertuje tekst z kodowania ISO-8952 do CP-1250
//narazie taka sobie bo nie moge znale odpowiedniego polecenia
var
  A:Word;
begin
  for A:=1 to Length(Text)-1 do
  begin
    if Text[A]='' then Text[A]:=''
    else if Text[A]='' then Text[A]:=''
    else if Text[A]='' then Text[A]:='';
  end;
end;

procedure GetLastCdFile(const CDDrive:Char; var CDHeader:TCDHeader);
var
  SR:TSearchRec;
  Date:Integer;
  Next:Integer;
begin
  Date:=0;
  Next:=FindFirst(CDDrive+':\*', faAnyFile, SR);
  while Next=0 do
  begin
    if SR.Time>Date then Date:=SR.Time;
    Next:=FindNext(SR);
  end;
//  FindClose(SR);
///  CDHeader.Year:=Int(FormatDateTime('yyyy', FileDateToDateTime(Date));
//  CDHeader.Month:=Int(FormatDateTime('mmm', FileDateToDateTime(Date));
end;

