library ksniezb;

uses
  Windows, SysUtils, Classes;

{$I '..\types.inc'}
{$I '..\functions.inc'}
{$R ksniezb+.RES}
{$R *.RES}

var
  CDDrive:Char;

//
//Procedury dodatkowe
//
function ExtractLicense(const HTML:string):TLicense;
var
  TempPos:Word;
  License:string;
begin
  TempPos:=Pos('licencja_text>',HTML)+14;//pozycja pierwszej litery licencji
  License:=Copy(HTML, TempPos, Length(HTML)-TempPos);//wycicie tekstu przed licencj
  TempPos:=Pos('<', License)-1;//pozycja ostatniej litery licencji=dugo licencji
  License:=Copy(License, 1, TempPos);//wydzielenie licencji
  License:=Trim(License);//usunicie zbdnych spacji i innych znakw biaych
  Result:=TextToLicense(License);//przeksztacenie nazwy licencji na typ TLicense
end;

procedure ExtractNameDescription(const HTML:string; var Name,Description:string);
var
  TempPos:Word;
  Temp:string;
begin
    TempPos:=Pos('<TITLE>', HTML)+7;
    Temp:=Copy(HTML, TempPos, Length(HTML)-TempPos);
    TempPos:=Pos('</TITLE>',Temp)-1;//pozycja ostatniej litery nazwy programu
    Name:=Copy(Temp, 1, TempPos);//wycignicie nazwy programu
    IsoToCp(Name);
    TempPos:=Pos('<font face="Arial" size="2" ><div style="margin-top: 10 ; margin-left : 6px; margin-right : 6px;" >', Temp)+98;
    Delete(Temp, 1, TempPos);
    TempPos:=Pos('<', Temp)-1;//pozycja ostatniego znaku opisu=dugoc opisu
    Description:=Copy(Temp, 1, TempPos);//wycignicie opisu
    Description:=Trim(Description);//usunicie biaych znakw
    IsoToCp(Description);
end;

//
//Procedury eksportowane
//

procedure Info; stdcall;
begin
  MessageBox(0, 'Wtyczka do programu Wyszukiwarka'#13+
                         'Obsuguje pyty magazynu Komputer wiat Twj Niezbdnik'
                         ,'Informacje o wtyczce',MB_OK);
end;

function PluginName:PChar; stdcall;
begin
  Result:='K Twj Niezbdnik';
end;

function CDName:PChar; stdcall;
begin
  Result:='K Twj Niezbdnik';
end;

function CanYouRegister:TCanYouRegisterResult; stdcall;
begin
  Result:=No;
  try
    if (FileExists(CDDrive+':\ks.ico')
    and FileExists(CDDrive+':\autorun.inf')
    and FileExists(CDDrive+':\instaluj.exe'))
    then Result:=Yes;
  except
    MessageBox(0, 'Wystpi bd. Prosz skontaktowa si z autorem wtyczki.',nil,MB_OK+MB_ICONWARNING);
  end;
end;

function RegisterCD(var CDStream, ItemStream:TMemoryStream;
  CDHeader:TCDHeader; ShowProgress:TShowProgress):TRegisterCDResult; stdcall;
//gwna procedura rejestrujca pyt
var
  IH:TItemHeader;
  CDTitle, Name, Description, Version:string;
  DataFile:TStringList;
  A:Word;
  SR:TSearchRec;
  Found, Count:Integer;
begin
  Result:=Error;
  try
    CDStream.Position:=CDStream.Size; //ustawienie strumieni na koniec
    ItemStream.Position:=ItemStream.Size;
    ItemStream.Position:=ItemStream.Size;
    ItemStream.Position:=ItemStream.Size;
    ShowProgress(0);
    CDHeader.Month:=13;
    CDHeader.Year:=2000+StrToInt(Copy(CDHeader.DiskLabel, 10, 2));
    CDTitle:='K Twj Niezbdnik '+Copy(CDHeader.DiskLabel,8,2)+'/'+Copy(CDHeader.DiskLabel, 10, 2);
    CDHeader.TitleLength:=Length(CDTitle);
    CDStream.Position:=CDStream.Size;
    CDStream.Write(CDHeader, SizeOf(CDHeader));
    CDStream.Write(CDTitle[1], CDHeader.TitleLength);
    //liczymy liczb programw
    Count:=0;
    Found:=FindFirst(CDDrive+':\datalo\htm\*.htm', faAnyFile, SR);
    while Found=0 do
    begin
      Inc(Count);
      Found:=FindNext(SR);
    end;
    FindClose(SR);

    DataFile:=TStringList.Create;
    try
      A:=0;
      Found:=FindFirst(CDDrive+':\datalo\htm\*.htm', faAnyFile, SR);
      while Found=0 do
      begin
        Inc(A);
        ShowProgress(100*A div Count);
        SR.Name:=LowerCase(SR.Name); //zmniejszenie wszystkich liter w nazwie pliku
        if ((SR.Name='archiwum.htm') or (SR.Name='blank.htm') or (SR.Name='nowy.html')  or
           (SR.Name='wyszukiwarka.htm')  or (SR.Name='wyszukiwarka_prog.htm')) then
        begin
          Found:=FindNext(SR);
          Continue;
        end;


        begin
          DataFile.LoadFromFile(CDDrive+':\datalo\htm\'+SR.Name);
          ExtractNameDescription(DataFile.Text, Name, Description);
          if Description='program' then MessageBox(0, PChar(Description), PChar(SR.Name+'>'+Name), MB_OK);
          ExtractNameVer(Name, Name, Version);
          IH.CDNumber:=CDHeader.CDNumber;
          IH.NameLength:=Length(Name);
          IH.DescriptionLength:=Length(Description);
          IH.License:=ExtractLicense(DataFile.Text);
          IH.CompanyLength:=0;
          IH.VersionLength:=Length(Version);

          ItemStream.Position:=ItemStream.Size;
          ItemStream.Write(IH, SizeOf(IH));
          if IH.NameLength>0 then ItemStream.Write(Name[1], IH.NameLength);
          if IH.VersionLength>0 then ItemStream.Write(Version[1], IH.VersionLength);
          if IH.DescriptionLength>0 then ItemStream.Write(Description[1], IH.DescriptionLength);
        end;
        Found:=FindNext(SR);
      end;
      FindClose(SR);
      Result:=Registered;
    finally
      DataFile.Free;
    end;
  except
    MessageBox(0, 'Wystpi bd. Prosz skontaktowa si z autorem.',nil,MB_OK);
  end;
end;

function InitializePlugin(const CDLetter:Char):Boolean;
begin
  CDDrive:=CDLetter;
  Result:=True;
end;

exports
  RegisterCD,
  CanYouRegister,
  PluginName,
  CDName,
  Info,
  InitializePlugin;
end.
